package benchmark.random.gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Rectangle;
import java.io.File;

import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;

import benchmark.random.RBCDisCSPGenerator;
import gui.generators.Generator;

public class ComplexRandomTKCPanel extends Generator {

	/**
	 * 
	 */
	private static final long serialVersionUID = 7555112515918490404L;
	private JPanel principalPanel = null;
	private JPanel southPanel = null;
	private JPanel northPanel = null;
	private JLabel nbInstanceLabel = null;
	private JLabel nbAgentLabel = null;
	private JLabel domainSizeLabel = null;
	private JLabel Cxlabel = null;
	private JLabel CpCxlabel = null;
	private JLabel fromLabel = null;
	private JLabel toLabel = null;
	private JLabel stepLabel = null;
	private JSpinner minCx = null;
	private JSpinner maxCx = null;
	private JSpinner stepCx = null;
	private JSpinner minCpCx = null;
	private JSpinner maxCpCx = null;
	private JSpinner stepCpCx = null;
	private JSpinner nbAgents = null;
	private JSpinner nbVarsPerAgent = null;
	private JSpinner nbInstance = null;
	private JSpinner domainSize = null;
	private JSpinner minP1 = null;
	private JSpinner maxP1 = null;
	private JSpinner stepP1 = null;
	private JSpinner minP2 = null;
	private JSpinner maxP2 = null;
	private JSpinner stepP2 = null;
	private JLabel nbVarsPerAgentLabel = null;
	private JLabel densityLabel = null;
	private JLabel P2label = null;

	/**
	 * This is the default constructor
	 */
	public ComplexRandomTKCPanel() {
		super();
		this.add(this.getPrincipalPanel(), BorderLayout.CENTER);
	}

	protected JPanel getPrincipalPanel() {
		if (principalPanel == null) {
			principalPanel = new JPanel();
			Cxlabel = new JLabel("Connections", JLabel.RIGHT);
			Cxlabel.setBounds(new Rectangle(50, 40, 120, 22));
			CpCxlabel = new JLabel("Constr. per connection", JLabel.RIGHT);
			CpCxlabel.setBounds(new Rectangle(10, 70, 160, 22));
			densityLabel = new JLabel("local constraints density", JLabel.RIGHT);
			densityLabel.setBounds(new Rectangle(10, 100, 160, 20));
			P2label = new JLabel("Thigthness", JLabel.RIGHT);
			P2label.setBounds(new Rectangle(10, 130, 160, 20));
			fromLabel = new JLabel("From", JLabel.CENTER);
			fromLabel.setBounds(new Rectangle(180, 0, 50, 25));
			toLabel = new JLabel("To", JLabel.CENTER);
			toLabel.setBounds(new Rectangle(270, 0, 50, 25));
			stepLabel = new JLabel("Step", JLabel.CENTER);
			stepLabel.setBounds(new Rectangle(360, 0, 50, 25));
			nbInstanceLabel = new JLabel("Number of instances", JLabel.RIGHT);
			nbInstanceLabel.setBounds(new Rectangle(80, 10, 150, 22));
			nbAgentLabel = new JLabel("Number of agents", JLabel.RIGHT);
			nbAgentLabel.setBounds(new Rectangle(80, 45, 150, 22));
			nbVarsPerAgentLabel = new JLabel("Number of Vars per Agents", JLabel.RIGHT);
			nbVarsPerAgentLabel.setBounds(new Rectangle(50, 80, 180, 25));
			domainSizeLabel = new JLabel("Domain Size", JLabel.RIGHT);
			domainSizeLabel.setBounds(new Rectangle(80, 115, 150, 22));
			principalPanel.setLayout(new FlowLayout());
			principalPanel.setPreferredSize(new Dimension(500, 320));
			principalPanel.setMinimumSize(new Dimension(500, 320));
			principalPanel.add(getNorthPanel(), BorderLayout.NORTH);
			principalPanel.add(getSouthPanel(), BorderLayout.CENTER);
		}
		return principalPanel;
	}

	/**
	 * This method initializes minCx
	 * 
	 * @return javax.swing.JTextField
	 */
	public JSpinner getMinCx() {
		if (minCx == null) {
			minCx = new JSpinner(new SpinnerNumberModel(0.40, 0.01, 1, 0.01));
			minCx.setBounds(new Rectangle(180, 40, 60, 22));
		}
		return minCx;
	}

	/**
	 * This method initializes maxCx
	 * 
	 * @return javax.swing.JTextField
	 */
	public JSpinner getMaxCx() {
		if (maxCx == null) {
			maxCx = new JSpinner(new SpinnerNumberModel(0.70, 0.01, 1, 0.01));
			maxCx.setBounds(new Rectangle(270, 40, 60, 22));
		}
		return maxCx;
	}

	/**
	 * This method initializes stepCx
	 * 
	 * @return javax.swing.JTextField
	 */
	public JSpinner getStepCx() {
		if (stepCx == null) {
			stepCx = new JSpinner(new SpinnerNumberModel(0.30, 0.01, 1, 0.01));
			stepCx.setBounds(new Rectangle(360, 40, 60, 22));
		}
		return stepCx;
	}

	/**
	 * This method initializes minCpCx
	 * 
	 * @return javax.swing.JTextField
	 */
	public JSpinner getMinCpCx() {
		if (minCpCx == null) {
			minCpCx = new JSpinner(new SpinnerNumberModel(0.40, 0.01, 1, 0.01));
			minCpCx.setBounds(new Rectangle(180, 70, 60, 22));
		}
		return minCpCx;
	}

	/**
	 * This method initializes maxCpCx
	 * 
	 * @return javax.swing.JTextField
	 */
	public JSpinner getMaxCpCx() {
		if (maxCpCx == null) {
			maxCpCx = new JSpinner(new SpinnerNumberModel(0.70, 0.01, 1, 0.01));
			maxCpCx.setBounds(new Rectangle(270, 70, 60, 22));
		}
		return maxCpCx;
	}

	/**
	 * This method initializes stepCpCx
	 * 
	 * @return javax.swing.JTextField
	 */
	public JSpinner getStepCpCx() {
		if (stepCpCx == null) {
			stepCpCx = new JSpinner(new SpinnerNumberModel(0.30, 0.01, 1, 0.01));
			stepCpCx.setBounds(new Rectangle(360, 70, 60, 22));
		}
		return stepCpCx;
	}

	/**
	 * This method initializes nbAgents
	 * 
	 * @return javax.swing.JSpinner
	 */
	private JSpinner getNbAgents() {
		if (nbAgents == null) {
			nbAgents = new JSpinner(new SpinnerNumberModel(5, 1, 50, 1));
			nbAgents.setBounds(new Rectangle(250, 45, 60, 22));
		}
		return nbAgents;
	}

	/**
	 * This method initializes nbVarsPerAgent
	 * 
	 * @return javax.swing.JSpinner
	 */
	private JSpinner getNbVarsPerAgent() {
		if (nbVarsPerAgent == null) {
			nbVarsPerAgent = new JSpinner(new SpinnerNumberModel(2, 1, 10, 1));
			nbVarsPerAgent.setBounds(new Rectangle(250, 80, 60, 22));
		}
		return nbVarsPerAgent;
	}

	/**
	 * This method initializes nbInstance
	 * 
	 * @return javax.swing.JSpinner
	 */
	private JSpinner getNbInstance() {
		if (nbInstance == null) {
			nbInstance = new JSpinner(new SpinnerNumberModel(25, 1, 100, 1));
			nbInstance.setBounds(new Rectangle(250, 10, 60, 22));
		}
		return nbInstance;
	}

	/**
	 * This method initializes domainSize
	 * 
	 * @return javax.swing.JSpinner
	 */
	private JSpinner getDomainSize() {
		if (domainSize == null) {
			domainSize = new JSpinner(new SpinnerNumberModel(10, 1, 100, 1));
			domainSize.setBounds(new Rectangle(250, 115, 60, 22));
		}
		return domainSize;
	}

	/**
	 * This method initializes minP1
	 * 
	 * @return javax.swing.JTextField
	 */
	public JSpinner getMinP1() {
		if (minP1 == null) {
			minP1 = new JSpinner(new SpinnerNumberModel(0.20, 0.01, 1, 0.01));
			minP1.setBounds(new Rectangle(180, 100, 60, 22));
		}
		return minP1;
	}

	/**
	 * This method initializes maxP1
	 * 
	 * @return javax.swing.JTextField
	 */
	public JSpinner getMaxP1() {
		if (maxP1 == null) {
			maxP1 = new JSpinner(new SpinnerNumberModel(0.80, 0.01, 1, 0.01));
			maxP1.setBounds(new Rectangle(270, 100, 60, 22));
		}
		return maxP1;
	}

	/**
	 * This method initializes stepP1
	 * 
	 * @return javax.swing.JTextField
	 */
	public JSpinner getStepP1() {
		if (stepP1 == null) {
			stepP1 = new JSpinner(new SpinnerNumberModel(0.10, 0.01, 1, 0.01));
			stepP1.setBounds(new Rectangle(360, 100, 60, 22));
		}
		return stepP1;
	}

	/**
	 * This method initializes minP2
	 * 
	 * @return javax.swing.JTextField
	 */
	public JSpinner getMinP2() {
		if (minP2 == null) {
			minP2 = new JSpinner(new SpinnerNumberModel(0.10, 0.01, 1, 0.01));
			minP2.setBounds(new Rectangle(180, 130, 60, 22));
		}
		return minP2;
	}

	/**
	 * This method initializes maxP2
	 * 
	 * @return javax.swing.JTextField
	 */
	public JSpinner getMaxP2() {
		if (maxP2 == null) {
			maxP2 = new JSpinner(new SpinnerNumberModel(0.90, 0.01, 1, 0.01));
			maxP2.setBounds(new Rectangle(270, 130, 60, 22));
		}
		return maxP2;
	}

	/**
	 * This method initializes stepP2
	 * 
	 * @return javax.swing.JTextField
	 */
	public JSpinner getStepP2() {
		if (stepP2 == null) {
			stepP2 = new JSpinner(new SpinnerNumberModel(0.10, 0.01, 1, 0.01));
			stepP2.setBounds(new Rectangle(360, 130, 60, 22));
		}
		return stepP2;
	}

	/**
	 * This method initializes southPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getSouthPanel() {
		if (southPanel == null) {
			southPanel = new JPanel();
			southPanel.setLayout(null);
			southPanel.add(fromLabel, null);
			southPanel.add(toLabel, null);
			southPanel.add(stepLabel, null);
			southPanel.add(Cxlabel, null);
			southPanel.add(CpCxlabel, null);
			southPanel.add(densityLabel, null);
			southPanel.add(P2label, null);
			southPanel.add(getMinCx(), null);
			southPanel.add(getMaxCx(), null);
			southPanel.add(getStepCx(), null);
			southPanel.add(getMinCpCx(), null);
			southPanel.add(getMaxCpCx(), null);
			southPanel.add(getStepCpCx(), null);
			southPanel.add(getMinP1(), null);
			southPanel.add(getMaxP1(), null);
			southPanel.add(getStepP1(), null);
			southPanel.add(getMinP2(), null);
			southPanel.add(getMaxP2(), null);
			southPanel.add(getStepP2(), null);
			southPanel.setPreferredSize(new Dimension(460, 160));
			southPanel.setMinimumSize(new Dimension(460, 160));
		}
		return southPanel;
	}

	/**
	 * This method initializes northPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getNorthPanel() {
		if (northPanel == null) {
			northPanel = new JPanel();
			northPanel.setLayout(null);
			northPanel.add(nbInstanceLabel, null);
			northPanel.add(nbAgentLabel, null);
			northPanel.add(nbVarsPerAgentLabel, null);
			northPanel.add(domainSizeLabel, null);
			northPanel.add(getNbInstance(), null);
			northPanel.add(getNbAgents(), null);
			northPanel.add(getNbVarsPerAgent(), null);
			northPanel.add(getDomainSize(), null);
			northPanel.setPreferredSize(new Dimension(400, 140));
			northPanel.setMinimumSize(new Dimension(400, 140));
			northPanel.add(getSouthPanel(), null);
		}
		return northPanel;
	}

	public void generate(File file) {
		int nbInstance = (Integer) getNbInstance().getValue();
		int nbAgent = (Integer) getNbAgents().getValue();
		int nbVarsPerAgent = (Integer) getNbAgents().getValue();
		int domainSize = (Integer) getDomainSize().getValue();
		double minP1 = (Double) (this.getMinP1().getValue());
		double maxP1 = (Double) (this.getMaxP1().getValue());
		double stepP1 = (Double) (this.getStepP1().getValue());
		double minP2 = (Double) (this.getMinP2().getValue());
		double maxP2 = (Double) (this.getMaxP2().getValue());
		double stepP2 = (Double) (this.getStepP2().getValue());
		double minCx = (Double) (getMinCx().getValue());
		double maxCx = (Double) (getMaxCx().getValue());
		double stepCx = (Double) (getStepCx().getValue());
		double minCpCx = (Double) (getMinCpCx().getValue());
		double maxCpCx = (Double) (getMaxCpCx().getValue());
		double stepCpCx = (Double) (getStepCpCx().getValue());
		RBCDisCSPGenerator g = new RBCDisCSPGenerator(file, nbInstance, nbAgent, nbVarsPerAgent, domainSize);
		g.setConnection(minCx, maxCx, stepCx);
		g.setConstraintsPerConnection(minCpCx, maxCpCx, stepCpCx);
		g.setLocalConstraintDensity(minP1, maxP1, stepP1);
		g.setTightness(minP2, maxP2, stepP2);

		g.generate();
		file = null;
		JOptionPane.showMessageDialog(this, "Problems was generated with success");
		return;
	}

} // @jve:decl-index=0:visual-constraint="11,9"
