package gui.generators;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Rectangle;
import java.io.File;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class RTreeGraphPanel extends Generator {

	public static final long serialVersionUID = 1L;
	private JTextField nbInstance = null;
	private JTextField nbLevel = null;
	private JTextField nbChild = null;
	private JTextField domainSize = null;

	private JLabel nbInstanceLabel = null;
	private JLabel levelLabel = null;
	private JLabel nbChildLabel = null;
	private JLabel domainSizeLabel = null;
	private JLabel fromLabel = null;
	private JLabel toLabel = null;
	private JLabel stepLabel = null;
	private JLabel P1label = null;
	private JLabel P2label = null;

	private JTextField minP1 = null;
	private JTextField maxP1 = null;
	private JTextField stepP1 = null;
	private JTextField minP2 = null;
	private JTextField maxP2 = null;
	private JTextField stepP2 = null;
	private JPanel principalPanel = null;

	/**
	 * This is the default constructor
	 */
	public RTreeGraphPanel() {
		super();
		this.add(this.getPrincipalPanel(), BorderLayout.CENTER);
	}

	protected JPanel getPrincipalPanel() {
		if (principalPanel == null) {
			principalPanel = new JPanel();
			fromLabel = new JLabel();
			fromLabel.setBounds(new Rectangle(150, 180, 50, 22));
			fromLabel.setText("From");
			toLabel = new JLabel();
			toLabel.setBounds(new Rectangle(220, 180, 50, 22));
			toLabel.setText("To");
			stepLabel = new JLabel();
			stepLabel.setBounds(new Rectangle(290, 180, 50, 22));
			stepLabel.setText("Step");
			P1label = new JLabel();
			P1label.setBounds(new Rectangle(75, 215, 50, 22));
			P1label.setText("P1");
			P2label = new JLabel();
			P2label.setBounds(new Rectangle(75, 260, 50, 22));
			P2label.setText("P2");
			nbInstanceLabel = new JLabel();
			nbInstanceLabel.setBounds(new Rectangle(75, 25, 150, 22));
			nbInstanceLabel.setText("Number of instance");
			nbInstanceLabel.setHorizontalAlignment(JLabel.RIGHT);
			levelLabel = new JLabel();
			levelLabel.setBounds(new Rectangle(75, 60, 150, 22));
			levelLabel.setText("Number of levels");
			levelLabel.setHorizontalAlignment(JLabel.RIGHT);
			nbChildLabel = new JLabel();
			nbChildLabel.setBounds(new Rectangle(75, 95, 150, 22));
			nbChildLabel.setText("Number of child");
			nbChildLabel.setHorizontalAlignment(JLabel.RIGHT);
			domainSizeLabel = new JLabel();
			domainSizeLabel.setBounds(new Rectangle(75, 130, 150, 22));
			domainSizeLabel.setText("Size of domain");
			domainSizeLabel.setHorizontalAlignment(JLabel.RIGHT);
			principalPanel.setLayout(null);
			principalPanel.setSize(new Dimension(400, 400));
			principalPanel.setPreferredSize(new Dimension(400, 400));
			principalPanel.setMinimumSize(new Dimension(400, 400));
			principalPanel.add(getNbInstance(), null);
			principalPanel.add(nbInstanceLabel, null);
			principalPanel.add(getNbLevel(), null);
			principalPanel.add(levelLabel, null);
			principalPanel.add(getNbChild(), null);
			principalPanel.add(nbChildLabel, null);
			principalPanel.add(getDomainSize(), null);
			principalPanel.add(domainSizeLabel, null);
			principalPanel.add(fromLabel, null);
			principalPanel.add(toLabel, null);
			principalPanel.add(stepLabel, null);
			principalPanel.add(P1label, null);
			principalPanel.add(P2label, null);
			principalPanel.add(getMinP1(), null);
			principalPanel.add(getMinP2(), null);
			principalPanel.add(getStepP1(), null);
			principalPanel.add(getStepP2(), null);
			principalPanel.add(getMaxP2(), null);
			principalPanel.add(getMaxP1(), null);

		}
		return principalPanel;
	}

	/**
	 * This method initializes nbInstance
	 * 
	 * @return javax.swing.JTextField
	 */
	public JTextField getNbInstance() {
		if (nbInstance == null) {
			nbInstance = new JTextField();
			nbInstance.setBounds(new Rectangle(250, 25, 40, 25));
			nbInstance.setText("20");
		}
		return nbInstance;
	}

	/**
	 * This method initializes nbChild
	 * 
	 * @return javax.swing.JTextField
	 */
	public JTextField getNbChild() {
		if (nbChild == null) {
			nbChild = new JTextField();
			nbChild.setBounds(new Rectangle(250, 95, 40, 25));
			nbChild.setText("3");
		}
		return nbChild;
	}

	/**
	 * This method initializes domainSize
	 * 
	 * @return javax.swing.JTextField
	 */
	public JTextField getDomainSize() {
		if (domainSize == null) {
			domainSize = new JTextField();
			domainSize.setBounds(new Rectangle(250, 130, 40, 25));
			domainSize.setText("10");
		}
		return domainSize;
	}

	/**
	 * This method initializes nbLevel
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getNbLevel() {
		if (nbLevel == null) {
			nbLevel = new JTextField();
			nbLevel.setBounds(new Rectangle(250, 60, 40, 25));
			nbLevel.setText("4");
		}
		return nbLevel;
	}

	public void generate(File path) {
	// TODO Auto-generated method stub

	}

	/**
	 * This method initializes minP1
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getMinP1() {
		if (minP1 == null) {
			minP1 = new JTextField();
			minP1.setBounds(new Rectangle(150, 215, 40, 22));
			minP1.setText("0.40");
		}
		return minP1;
	}

	/**
	 * This method initializes minP2
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getMinP2() {
		if (minP2 == null) {
			minP2 = new JTextField();
			minP2.setBounds(new Rectangle(150, 260, 40, 22));
			minP2.setText("0.10");
		}
		return minP2;
	}

	/**
	 * This method initializes stepP1
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getStepP1() {
		if (stepP1 == null) {
			stepP1 = new JTextField();
			stepP1.setBounds(new Rectangle(290, 215, 40, 22));
			stepP1.setText("0.30");
		}
		return stepP1;
	}

	/**
	 * This method initializes stepP2
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getStepP2() {
		if (stepP2 == null) {
			stepP2 = new JTextField();
			stepP2.setBounds(new Rectangle(290, 260, 40, 22));
			stepP2.setText("0.10");
		}
		return stepP2;
	}

	/**
	 * This method initializes maxP2
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getMaxP2() {
		if (maxP2 == null) {
			maxP2 = new JTextField();
			maxP2.setBounds(new Rectangle(220, 260, 40, 22));
			maxP2.setText("0.90");
		}
		return maxP2;
	}

	/**
	 * This method initializes maxP11
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getMaxP1() {
		if (maxP1 == null) {
			maxP1 = new JTextField();
			maxP1.setBounds(new Rectangle(220, 215, 40, 22));
			maxP1.setText("0.70");
		}
		return maxP1;
	}

} // @jve:decl-index=0:visual-constraint="10,10"
