package kernel.order;

import java.util.HashMap;
import java.util.Random;

import util.IntArray;

/**
 * A class for random ordering
 * 
 * @author Redouane EZZAHIR
 * 
 */
public class RandomAO extends CentralizedAO implements ChainOrder {

	Random rand = new Random();

	/*
	 * (non-Javadoc)
	 * 
	 * @see order.CentralizedAgentOrdering#buildAgentsOrder()
	 */
	public IntArray buildAgentsOrder() {
		rand.setSeed(System.currentTimeMillis());
		IntArray order = new IntArray();
		int n = this.agentsComplexity.keySet().size();
		int[] index = new int[n];
		for (int i = 0 ; i < n ; i++) {
			index[i] = i + 1;
		}
		for (int i = 0 ; i < n ; i++) {
			int choosen = this.rand.nextInt(n - i);
			order.add(index[choosen], i);
			index[choosen] = index[n - i - 1];
		}
		// System.out.println(order);
		return order;
	}

	public static IntArray buildpriorityTree(HashMap<Integer, AgentComplexity> complexities) {
		Random rand = new Random();
		rand.setSeed(System.currentTimeMillis());
		IntArray order = new IntArray();
		int n = complexities.keySet().size();
		int[] index = new int[n];
		for (int i = 0 ; i < n ; i++) {
			index[i] = i + 1;
		}
		for (int i = 0 ; i < n ; i++) {
			int choosen = rand.nextInt(n - i);
			order.add(index[choosen], i);
			index[choosen] = index[n - i - 1];
		}
		return order;
	}
}
