/*************************************************************************

 **************************************************************************/

package simple.dcsp.abtfamily.abtdo;

import kernel.StopException;
import kernel.com.Message;
import kernel.com.MessageHandler;
import util.Commands;
import util.IntArray;
import util.VarAssignment;

public class OkMsgHandler extends MessageHandler {

	public OkMsgHandler(ABTDOAgent agent) {
		super(agent, Commands.OK);
	}

	/**
	 * @param msg
	 */
	public void processMessage(Message msg) throws StopException {
		VarAssignment senderAss = (VarAssignment) msg.get(Commands.OK);
		if (this.myAgent.agentView.compareTimeCounter(senderAss) >= 0) {
			this.myAgent.agentView.priorityMerge(senderAss);
			((ABTDOAgent) this.myAgent).CheckAgentView();
		} else {
			this.myAgent.auxiliaryStatistics.get(Commands.ObsoleteOk).value++;
		}
	}

	/**
	 * 
	 */
	public void sendOkMessages() {
		IntArray neighbors = this.myAgent.communicator.getNeighbors();
		for (int neig : neighbors) {
			this.sendOkMessage(neig);
		}
	}

	/**
	 * 
	 */
	public void sendOkMessage(int receiverId) {
		VarAssignment myAssignment = ((ABTDOAgent) this.myAgent).var.getVarAssignment();
		Message msg = this.createMessage();
		msg.addContents(Commands.OK, myAssignment);
		msg.setReceiverId(receiverId);
		((ABTDOAgent) this.myAgent).storeStatisticsFor(msg);
		this.myAgent.sendMessage(msg);
	}

}
