package simple.dcsp.afcfamily.afc;

import java.util.ArrayList;
import java.util.Collection;

import kernel.AbstractAgent;
import kernel.AbstractMaster;
import kernel.order.LexicographicAO;
import util.Commands;

public class AFCMaster extends AbstractMaster {

	protected boolean recording;

	public AFCMaster(boolean recording) {
		this.setCentralizedAO(new LexicographicAO());
		this.recording = recording;
	}

	@Override
	public AbstractAgent makeAgent(int agId, String name, String description) {
		if (this.recording) { return new AFCNRAgent(agId, name, description); }
		return new AFCAgent(agId, name, description);
	}

	/* (non-Javadoc)
	 * @see kernel.AbstractMaster#getTypesOfMessages()
	 */
	@Override
	public Collection<String> getTypesOfMessages() {
		Collection<String> ans = new ArrayList<String>();
		ans.add(Commands.CPA);
		ans.add(Commands.BACKTRACK);
		ans.add(Commands.FC_CPA);
		ans.add(Commands.NOT_OK);
		ans.add(Commands.TERMINATION_DETETION);
		return ans;
	}


}
