package simple.dcsp.afcfamily.afc.domdeg;

import java.util.HashMap;

import kernel.AbstractAgent;
import kernel.com.Message;
import kernel.order.AgentComplexity;
import kernel.order.LexicographicAO;
import simple.dcsp.afcfamily.afc.AFCMaster;
import util.Commands;
import util.IntArray;

public class AFCMinDomMaster extends AFCMaster {

	public static final int MinDom = 0;
	public static final int Dom_Static_Deg = 1;
	public static final int Dom_Dyn_Deg = 2;

	public AFCMinDomMaster() {
		super(true);
		this.setCentralizedAO(new LexicographicAO());
	}

	@Override
	public AbstractAgent makeAgent(int agId, String name, String description) {
		return new AFCDomDegAgent(agId, name, description, MinDom);
	}

	public void broadcast(Message msg, int agentId) {
		if (msg.getType().equals(Commands.AO)) {
			HashMap<Integer, AgentComplexity> ac = this.centralizedAO.getAgentsComplexity();
			IntArray ao = (IntArray) msg.get(Commands.ORDER);
			for (int id : ao) {
				msg.addContents(id + "", new Integer(ac.get(id).getMaxDomain()));
			}
		}
		super.broadcast(msg, agentId);
	}

}
