package simple.dcsp.afcfamily.afcng.approximateDom;

import java.util.HashMap;

import kernel.AbstractAgent;
import kernel.com.Message;
import kernel.order.AgentComplexity;
import simple.dcsp.afcfamily.afcng.AFCngMaster;
import util.Commands;
import util.IntArray;

public class AFCngApproximateMinDomMaster extends AFCngMaster {

	private short type = MinDom;
	public static final short MinDom = 1;
	public static final short MinDomDeg = 2;

	public AFCngApproximateMinDomMaster(short type) {
		this.type = type;
//		this.setCentralizedAO(new LexicographicAO());
	}

	@Override
	public AbstractAgent makeAgent(int agId, String name, String description) {
		return new AFCngApproximateMinDomAgent(agId, name, description, this.type);
	}

	public void broadcast(Message msg, int agentId) {
		if (msg.getType().equals(Commands.AO)) {
			HashMap<Integer, AgentComplexity> ac = this.centralizedAO.getAgentsComplexity();
			IntArray order = (IntArray) msg.get(Commands.ORDER);
			for (int agId : order){
				msg.addContents(agId + "", new Integer(ac.get(agId).getMaxDomain()));
			}
		}
		super.broadcast(msg, agentId);
	}

}
