package simple.dcsp.dba;

import kernel.AbstractAgent;
import kernel.StopException;
import kernel.com.Message;
import util.Commands;
import util.IntArray;
import util.VarAssignment;

public class OkMsgHandler extends kernel.com.MessageHandler {

	public OkMsgHandler(AbstractAgent agent) {
		super(agent, Commands.OK);
	}

	/**
	 * @param msg
	 */
	public void processMessage(Message msg) throws StopException {
		VarAssignment senderAss = (VarAssignment) msg.get(Commands.OK);
		((DBAagent) this.myAgent).processOk(senderAss);
	}

	/**
	 * 
	 */
	public void sendOkMessages() {
		IntArray lowerNeighbors = this.myAgent.communicator.getNeighbors();
		for (int i = 0 ; i < lowerNeighbors.size() ; i++) {
			this.sendOkMessage(lowerNeighbors.get(i));
		}
	}

	/**
	 * 
	 */
	public void sendOkMessage(int receiverId) {
		VarAssignment myVarAss = ((DBAagent) this.myAgent).var.getVarAssignment();
		Message msg = this.createMessage();
		msg.addContents(Commands.OK, myVarAss);
		msg.setReceiverId(receiverId);
		this.myAgent.sendMessage(msg);
	}
}
