package util;

import java.io.Serializable;
import java.util.Comparator;
import java.util.StringTokenizer;

public class DefaultComparator implements Comparator<VarAssignment>, Serializable {

	private static final long serialVersionUID = -2034287212234330234L;

	private IntArray order;

	public DefaultComparator(String str) {
		this.order = this.extractAgentIds(str);
	}

	@Override
	public int compare(VarAssignment v1, VarAssignment v2) {
		return order.indexOf(v1.getAgentId()) - order.indexOf(v2.getAgentId());
	}

	public IntArray extractAgentIds(String str) {
		IntArray ids = new IntArray();
		str = str.substring(1, str.indexOf("]"));
		StringTokenizer tok = new StringTokenizer(str, ",");
		while (tok.hasMoreTokens()) {
			int id = VarAssignment.fromString(tok.nextToken()).getAgentId();
			ids.add(id);
		}
		return ids;
	}

}
