package util;

import java.io.Serializable;

/**
 * An interface models a variable identifier
 * 
 * @author Redouane EZZAHIR
 * 
 */
public interface IVarIdentifier extends Comparable<IVarIdentifier>, Serializable {
	/**
	 * Returns the index of the variable with this identifier in its local problem
	 */
	public int getVarIndex();

	/**
	 * Returns the ID of the agent owning the variable with this identifier
	 */
	public int getAgentId();
}
