package util;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.StringWriter;
import java.math.BigInteger;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.Collection;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.TreeSet;
import java.util.Vector;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

/**
 * Class Utility
 */
@SuppressWarnings("unchecked")
public class Tools {

	/**
	 * Return current time as a string for printing
	 */
	public synchronized static String TimeString() {
		Date d = new Date(System.currentTimeMillis());
		return (d.toString());
	}

	/**
	 * 
	 */
	/**
     * 
     */
	public static HashMap<String, Double> merge(HashMap<String, Double> stat1, HashMap<String, Double> stat2) {
		HashMap<String, Double> statistics = new HashMap<String, Double>();// (HashMap<String, Long>) stat2.clone();
		Iterator<String> it = stat1.keySet().iterator();
		while (it.hasNext()) {
			String key = it.next();
			Double value = stat1.get(key);
			if (value == null)
				value = 0D;
			statistics.put(key, value);
		}
		it = stat2.keySet().iterator();
		while (it.hasNext()) {
			String key = it.next();
			Double value = stat2.get(key);
			if (value == null)
				value = 0D;
			if (statistics.containsKey(key)) {

				statistics.put(key, value + statistics.get(key));
			} else {
				statistics.put(key, value);
			}
		}
		return statistics;
	}

	// public static HashMap<String, Long> merge(HashMap<String, Long> stat1, HashMap<String, Long> stat2) {
	// HashMap<String, Long> statistics = (HashMap<String, Long>) stat2.clone();
	// Iterator<String> it = stat1.keySet().iterator();
	// while (it.hasNext()) {
	// String key = it.next();
	// if (statistics.containsKey(key)) {
	// statistics.put(key, stat1.get(key) + statistics.get(key));
	// } else {
	// statistics.put(key, stat1.get(key));
	// }
	// }
	// return statistics;
	// }

	// /**
	// *
	// */
	// public static HashMap<String, Long> mergeStatistics(HashMap<String, Long>
	// stat1, HashMap<String, Long> stat2) {
	// HashMap<String, Long> stat = new HashMap<String, Long>();
	// Iterator<String> it = stat1.keySet().iterator();
	// while (it.hasNext()) {
	// String key = it.next();
	// if (stat2.containsKey(key)) {
	// stat.put(key, stat1.get(key) + stat2.get(key));
	// } else {
	// stat.put(key, stat1.get(key));
	// }
	// }
	// return stat;
	// }

	/**
	 * @param arr
	 * @return the transpose of this matrix
	 */
	public synchronized static int[][] intArrayTranspose(int arr[][]) {
		int rez[][] = new int[arr[0].length][arr.length];
		for (int i = 0 ; i < arr[0].length ; i++) {
			for (int j = 0 ; j < arr.length ; j++) {
				rez[i][j] = arr[j][i];
			}
		}
		return rez;
	}

	public synchronized static final int combine_hash(int x, int y) {
		int rc = 0;
		for (int i = 7 ; i >= 0 ; --i) {
			if (i == 4)
				x = y;
			rc = rc * 21 + (char) x;
			x >>>= 8;
		}
		return rc;
	}

	/**
	 * @param v1
	 * @param v2
	 * @return the intersection of these two vectors
	 */
	public synchronized static Vector vectorIntersection(Vector v1, Vector v2) {
		Vector inters = new Vector();
		for (int i = 0 ; i < v1.size() ; i++) {
			for (int j = 0 ; j < v2.size() ; j++) {
				if (v1.elementAt(i).equals(v2.elementAt(j))) {
					int cnt = 0;
					boolean added = false;
					while (cnt < inters.size() && !added) {
						if (v1.elementAt(i).equals(inters.elementAt(cnt)))
							added = true;
						cnt++;
					}
					if (!added)
						inters.add(v1.elementAt(i));
				}
			}
		}
		return inters;
	}

	/**
	 * @param v1
	 * @param v2
	 * @return true if v1 has any element in common with v2
	 */

	public synchronized static boolean vectorsIntersect(Vector v1, Vector v2) {
		if (vectorIntersection(v1, v2).size() > 0)
			return true;
		else
			return false;
	}

	public synchronized static String vectorToString(Vector src) {
		String line = new String();
		if (src == null || src.size() == 0)
			return line;
		for (int i = 0 ; i < src.size() - 1 ; i++)
			line = line + src.elementAt(i) + " ";
		line = line + src.lastElement();
		return line;
	}

	/**
	 * @param src
	 * @param delimiter
	 * @return a string composed of the elements of the <code>src</code>, separated by <code>delimiter</code>
	 */

	public synchronized static String collectionToStringWithDelimiter(Collection src, String delimiter) {
		String line = new String();
		if (src == null || src.size() == 0)
			return line;
		for (Iterator iter = src.iterator() ; iter.hasNext() ;) {
			line = line + iter.next();
			if (iter.hasNext())
				line = line + delimiter;
		}
		return line;
	}

	public synchronized static String vectorToStringWithTabs(Collection src) {
		return collectionToStringWithDelimiter(src, "\t");
	}

	public static HashMap<Integer, Integer> IntegerHashMapfromString(String str) {
		HashMap<Integer, Integer> result = new HashMap<Integer, Integer>();
		str.trim();
		str = str.substring(1);
		str = str.substring(0, str.indexOf('}')).replaceAll(" ", "");
		StringTokenizer tok = new StringTokenizer(str.trim(), ",");
		while (tok.hasMoreTokens()) {
			String element = tok.nextToken();
			String[] keyval = element.split("=");
			result.put(Integer.parseInt(keyval[0]), Integer.parseInt(keyval[1]));
		}
		return result;
	}

	public synchronized static Vector<Integer> IntegerVectorFromString(String line) {
		Vector<Integer> res = null;
		if (line != null) {
			try {
				res = new Vector<Integer>();
				StringTokenizer st = new StringTokenizer(line);
				// reading integers
				while (st.hasMoreElements()) {
					Integer tmp = Integer.valueOf(st.nextToken(", \t\n\r\f"));
					res.add(tmp);
				}
			} catch (Exception e) {
				e.printStackTrace();
				return null;
			}
		}
		return res;
	}

	// comma or space/tab separated
	public synchronized static int[] IntegerArrayFromString(String line, String separator) {
		int[] values = null;
		if (line != null) {
			String str = line.trim();
			if (str.startsWith("["))
				str = str.substring(1);
			if (str.endsWith("]"))
				str = str.substring(0, str.length() - 1);
			str = str.trim();
			if (!str.equalsIgnoreCase("")) {
				// System.out.println("Gonna build context from:|" + str + "|");
				StringTokenizer tok = new StringTokenizer(str, separator);
				values = new int[tok.countTokens()];
				int i = 0;
				while (tok.hasMoreTokens()) {
					values[i++] = Integer.parseInt(tok.nextToken().trim());
				}
			}
		}
		return values;
	}

	public synchronized static Vector DoubleVectorFromString(String line) {
		Vector res = null;
		if (line != null) {
			try {
				res = new Vector();
				StringTokenizer st = new StringTokenizer(line);

				// reading integers
				while (st.hasMoreElements()) {
					Double tmp = Double.valueOf(st.nextToken(", "));
					res.add(tmp);
				}
			} catch (Exception e) {
				e.printStackTrace();
				return null;
			}
		}
		return res;
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	// compares the two vectors and returns the number of elements that differ
	public synchronized static int compareVectors(Vector x, Vector y) {
		int i = 0;
		if (x.size() != y.size())
			return Integer.MAX_VALUE;
		// System.out.println("S1 = " + x.toString());
		// System.out.println("S2 = " + y.toString());
		try {
			for (int j = 0 ; j < x.size() ; j++) {
				if (!((Integer) x.elementAt(j)).equals((Integer) y.elementAt(j)))
					i++;
			}
		} catch (Exception e) {

			e.printStackTrace();
			return Integer.MAX_VALUE;
		}
		// System.out.println("=====>>>>> " + i);
		return i;
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	public synchronized static int compareArrays(int[] x, int[] y) {
		int i = 0;
		if (x.length != y.length)
			return Integer.MAX_VALUE;
		// System.out.println("S1 = " + x.toString());
		// System.out.println("S2 = " + y.toString());
		for (int j = 0 ; j < x.length ; j++) {
			if (x[j] != y[j])
				i++;
		}
		return i;
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	public synchronized static double arrayAverage(double[] array) {
		double rez = 0;
		for (int i = 0 ; i < array.length ; i++) {
			rez += array[i];
		}
		rez = rez / array.length;
		return rez;
	}

	// --------------------------------------------------------------------------------------------------------------------//

	public static int indexOfMax(int[] data) {
		int indexOfMax = 0; // initial guess
		if (data.length > 1)
			for (int i = 1 ; i < data.length ; i++)
				if (data[i] > data[indexOfMax])
					indexOfMax = i; // found a smaller value
		return indexOfMax;
	}

	// --------------------------------------------------------------------------------------------------------------------//

	public synchronized static int indexOfMin(int[] data) {
		int indexOfMin = 0; // initial guess
		if (data.length > 1)
			for (int i = 1 ; i < data.length ; i++)
				if (data[i] < data[indexOfMin])
					indexOfMin = i; // found a smaller value
		return indexOfMin;
	}

	// --------------------------------------------------------------------------------------------------------------------//

	public synchronized static int indexOfMin(double[] data) {
		int indexOfMin = 0; // initial guess
		for (int i = 1 ; i < data.length ; i++)
			if (data[i] < data[indexOfMin])
				indexOfMin = i; // found a smaller value
		return indexOfMin;
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	/**
	 *@return min value from the gevin array;
	 */
	public synchronized static double arrayMinimum(double[] array) {
		double min = Double.POSITIVE_INFINITY;
		for (int i = 0 ; i < array.length ; i++) {
			if (min > array[i])
				min = array[i];
		}
		return min;
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	public synchronized static double arrayMaximum(double[] array) {
		double max = Double.NEGATIVE_INFINITY;
		for (int i = 0 ; i < array.length ; i++) {
			if (max < array[i])
				max = array[i];
		}
		return max;
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	public synchronized static int arrayAverage(int[] array) {
		int rez = 0;
		for (int i = 0 ; i < array.length ; i++) {
			rez += array[i];
		}
		rez = rez / array.length;
		return rez;
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	/**
	 *@return min value from the gevin array;
	 */
	public synchronized static int arrayMinimum(int[] array) {
		return array[indexOfMin(array)];
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	public synchronized static int arrayMaximum(int[] array) {
		int max = Integer.MIN_VALUE;
		for (int i = 0 ; i < array.length ; i++) {
			if (max < array[i])
				max = array[i];
		}
		return max;
	}

	public static int sum(int[] array) {
		int res = 0;
		for (int i = 0 ; i < array.length ; i++)
			res += array[i];
		return res;
	}

	public static int sum(int[] array, int to) {
		int res = 0;
		for (int i = 0 ; i < array.length && i < to ; i++)
			res += array[i];
		return res;
	}

	// -----------------------------------------------------------------------------------------------------------------------//

	public synchronized static double vectorSum(Vector vect) {
		double rez = 0;
		for (int i = 0 ; i < vect.size() ; i++) {
			if (vect.elementAt(0) instanceof Integer)
				rez += ((Integer) vect.elementAt(i)).intValue();
			else
				rez += ((Double) vect.elementAt(i)).doubleValue();
		}
		return rez;
	}

	// -----------------------------------------------------------------------------------------------------------------------//

	public synchronized static double vectorAverage(Vector vect) {
		if (vect.size() == 0)
			return 0;
		return vectorSum(vect) / vect.size();
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	public synchronized static double vectorMin(Vector vect) {
		double min = Double.MAX_VALUE;
		for (int i = 0 ; i < vect.size() ; i++) {
			double cur = ((Double) vect.elementAt(i)).doubleValue();
			if (min > cur)
				min = cur;
		}
		return min;
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	public synchronized static double vectorMax(Vector vect) {
		double max = Double.MIN_VALUE;
		for (int i = 0 ; i < vect.size() ; i++) {
			double cur = ((Double) vect.elementAt(i)).doubleValue();
			if (max < cur)
				max = cur;
		}
		return max;
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	public synchronized static double vectorVariance(Vector data) {
		double var = 0;
		double mean = vectorAverage(data);
		for (int i = 0 ; i < data.size() ; i++) {
			double val = ((Long) data.get(i)).longValue();
			var = var + (val - mean) * (val - mean);
		}
		return Math.sqrt(var / (data.size() - 1));
	}

	// ---------------------------------------------------------------------------------------//

	public synchronized static boolean isAllArrayTrue(boolean[] array) {
		for (int i = 0 ; i < array.length ; i++) {
			if (!array[i])
				return false;
		}
		return true;
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	public synchronized static String arrayToString(boolean[] array) {
		StringBuffer sb = new StringBuffer();
		for (int i = 0 ; i < array.length - 1 ; i++) {
			sb.append(array[i] + " ");
		}
		sb.append(array[array.length - 1]);
		return sb.toString();
	}

	public synchronized static TreeSet<Integer> arrayToTreeSet(int[] array) {
		TreeSet<Integer> treeSet = new TreeSet<Integer>();
		for (int i = 0 ; i < array.length ; i++) {
			treeSet.add(array[i]);
		}
		return treeSet;
	}

	public synchronized static int[] arrayFromTreeSet(TreeSet<Integer> treeSet) {
		int[] array = new int[treeSet.size()];
		Iterator<Integer> it = treeSet.iterator();
		int i = 0;
		while (it.hasNext()) {
			array[i] = it.next();
			i++;
		}
		return array;
	}

	public synchronized static int[] arrange(int[] array) {
		TreeSet treeSet = Tools.arrayToTreeSet(array);
		return Tools.arrayFromTreeSet(treeSet);
	}

	/**
	 * if there are two equal numbers they take the same index
	 * 
	 * @param array
	 * 
	 */
	public synchronized static int[] arrangeByIndex(int[] array) {
		TreeSet treeSet = Tools.arrayToTreeSet(array);
		int[] arranged = Tools.arrayFromTreeSet(treeSet);
		int[] index = new int[array.length];
		for (int i = 0 ; i < index.length ; i++) {
			index[i] = Tools.indexOf(arranged, arranged[i]);
		}
		return index;
	}

	/**
	 * 
	 */
	public static float Homogeneity(HashMap<String, Long> statP2, float mediane) {
		float homogeneity = 0;
		Iterator<String> it = statP2.keySet().iterator();
		while (it.hasNext()) {
			String key = it.next();
			float value = statP2.get(key);
			homogeneity += (long) (Math.pow(Math.abs((value - mediane)), 2));
		}
		return homogeneity;
	}

	/**
	 * 
	 */
	public static float Average(HashMap<String, Long> statP2) {
		float mediane = 0;
		Iterator<String> it = statP2.keySet().iterator();
		while (it.hasNext()) {
			String key = it.next();
			mediane += statP2.get(key);
		}
		return mediane / statP2.size();
	}

	/**
	 * 
	 */
	public static void average(HashMap<String, Double> stat, int n) {
		Iterator<String> it = stat.keySet().iterator();
		while (it.hasNext()) {
			String key = it.next();
			stat.put(key, stat.get(key) / n);
		}
	}

	/**
	 * 
	 */
	public static int[] average(int[] stat, int n) {
		int[] ans = stat.clone();
		for (int i = 0 ; i < ans.length ; i++) {
			ans[i] /= n;
		}
		return ans;
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	public synchronized static String arrayToString(Object[] array) {
		return arrayToString(array, 0, array.length - 1);
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	public synchronized static String arrayToString(Object[] array, int start, int end) {
		if (array == null)
			return "";
		StringBuffer sb = new StringBuffer();
		if (end - start >= 0) {
			for (int i = start ; i < end ; i++) {
				sb.append(array[i] + ",");
			}
			sb.append(array[end]);
		}
		return sb.toString();
	}

	public synchronized static int[] IntegerArrayFromString(String str) {
		if (str == null)
			return null;// new int[0];
		if (str.startsWith("["))
			str = str.substring(1, str.indexOf("]")); // remove [ and ]
		StringTokenizer tok = new StringTokenizer(str);
		int[] array = new int[tok.countTokens()];
		int i = 0;
		while (tok.hasMoreTokens()) {
			array[i++] = Integer.parseInt(tok.nextToken());
		}
		return array;
	}

	public synchronized static short[] ShortArrayFromString(String str) {
		if (str.startsWith("["))
			str = str.substring(1, str.indexOf("]")); // remove [ and ]
		if (str == null)
			return null;// new int[0];
		StringTokenizer tok = new StringTokenizer(str);
		short[] array = new short[tok.countTokens()];
		int i = 0;
		while (tok.hasMoreTokens()) {
			array[i++] = Short.parseShort(tok.nextToken());
		}
		return array;
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	public synchronized static String arrayToString(int[] array, int start, int end) {
		if (array == null)
			return "null";
		StringBuffer sb = new StringBuffer();
		if (end - start >= 0) {
			for (int i = start ; i < end ; i++) {
				sb.append(array[i] + " ");
			}
			sb.append(array[end]);
		}
		return sb.toString();
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	public synchronized static String arrayToString(short[] array, int start, int end) {
		if (array == null)
			return "null";
		StringBuffer sb = new StringBuffer();
		if (end - start >= 0) {
			for (int i = start ; i < end ; i++) {
				sb.append(array[i] + " ");
			}
			sb.append(array[end]);
		}
		return sb.toString();
	}

	// -----------------------------------------------------------------------------------------------------------------------//

	public static String VectorToString(Vector v) {
		StringBuffer sb = new StringBuffer();
		Iterator it = v.iterator();
		while (it.hasNext()) {
			sb.append(it.next());
			if (it.hasNext())
				sb.append(",");
		}
		return sb.toString();
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	public synchronized static String arrayToString(int[] array) {
		return arrayToString(array, 0, array.length - 1);
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	public synchronized static String arrayToString(short[] array) {
		return arrayToString(array, 0, array.length - 1);
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	public synchronized static String arrayToString(int[][] array) {
		if (array == null)
			return "null";
		StringBuffer sb = new StringBuffer();
		for (int i = 0 ; i < array.length ; i++) {
			sb.append(arrayToString(array[i]) + "\n");
		}
		return sb.toString();
	}

	// -----------------------------------------------------------------------------------------------------------------------//

	public synchronized static Vector addVectors(Vector v1, Vector v2) {
		if (v1.size() != v2.size()) {
			System.out.println("vector sizes differ..." + v1.size() + "!=" + v2.size());
			return null;
		}
		Vector rez = new Vector();
		for (int i = 0 ; i < v1.size() ; i++) {
			Double o = new Double(((Double) v1.elementAt(i)).doubleValue() + ((Double) v2.elementAt(i)).doubleValue());
			rez.add(o);
		}
		return rez;
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	public synchronized static int[] addArrays(int[] v1, int[] v2) {
		int minLength = Math.min(v1.length, v2.length);
		int[] rez = null;
		if (v1.length < v2.length) {
			rez = new int[v2.length];
			System.arraycopy(v2, 0, rez, 0, v2.length);
		} else {
			rez = new int[v1.length];
			System.arraycopy(v1, 0, rez, 0, v1.length);
		}
		for (int i = 0 ; i < minLength ; i++) {
			rez[i] = v1[i] + v2[i];
		}
		return rez;
	}

	// -----------------------------------------------------------------------------------------------------------------------//

	public synchronized static Vector substractVectors(Vector v1, Vector v2) {
		if (v1 == null || v2 == null) {
			System.out.println("One vector is null: " + v1 + "==" + v2);
		}
		if (v1.size() != v2.size()) {
			System.out.println("vector sizes differ..." + v1.size() + "!=" + v2.size());
			return null;
		}
		Vector rez = new Vector();
		for (int i = 0 ; i < v1.size() ; i++) {
			Double o = new Double(((Double) v1.elementAt(i)).doubleValue() - ((Double) v2.elementAt(i)).doubleValue());
			rez.add(o);
		}
		return rez;
	}

	// -----------------------------------------------------------------------------------------------------------------------//

	public synchronized static Vector divideVector(Vector v1, double div) {
		if (v1 == null) {
			System.out.println("cannot divide null vector");
			return null;
		}
		if (div == 0) {
			System.out.println("cannot divide by 0");
			return null;
		}

		for (int i = 0 ; i < v1.size() ; i++) {
			v1.setElementAt(new Double(((Double) v1.elementAt(i)).doubleValue() / div), i);
		}
		return v1;
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	public synchronized static double[][] copyDoubleArray(double[][] src, double[][] dest) {
		if (src.length != dest.length || src[0].length != dest[0].length)
			return null;
		for (int i = 0 ; i < src.length ; i++)
			for (int j = 0 ; j < src[0].length ; j++)
				dest[i][j] = src[i][j];
		return src;
	}

	// -----------------------------------------------------------------------------------------------------------------------//

	public synchronized static Vector arrayToVector(double[] src) {
		if (src == null)
			return null;
		Vector dest = new Vector();
		for (int i = 0 ; i < src.length ; i++)
			dest.add(new Double(src[i]));
		return dest;
	}

	// -----------------------------------------------------------------------------------------------------------------------//

	public synchronized static Vector<Integer> arrayToVector(int[] src) {
		if (src == null)
			return null;
		Vector<Integer> dest = new Vector<Integer>();
		for (int i = 0 ; i < src.length ; i++)
			dest.add(new Integer(src[i]));
		return dest;
	}

	// -----------------------------------------------------------------------------------------------------------------------//

	public synchronized static Vector arrayToVector(Object[] src) {
		if (src == null)
			return null;
		Vector dest = new Vector();
		for (int i = 0 ; i < src.length ; i++)
			dest.add(src[i]);
		return dest;
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	public synchronized static double[] vectorToArray(Vector src) {
		if (src == null)
			return null;
		double[] dest = new double[src.size()];
		for (int i = 0 ; i < dest.length ; i++)
			dest[i] = ((Double) src.elementAt(i)).doubleValue();
		return dest;
	}

	// -----------------------------------------------------------------------------------------------------------------------//

	public synchronized static int[] generatePermutation(Random randomGenerator, int howm) {
		int[] perm = new int[howm];
		Vector orig = new Vector();
		for (int i = 0 ; i < howm ; i++) {
			orig.add(new Integer(i));
		}
		for (int i = 0 ; i < howm ; i++) {
			int which = randomGenerator.nextInt(howm - i);
			perm[i] = ((Integer) orig.elementAt(which)).intValue();
			orig.remove(which);
		}
		return perm;
	}

	public synchronized static int[] generatePermutation(Random randomGenerator, int[] perm) {
		// int[] perm = new int[howm];
		Vector<Integer> orig = new Vector<Integer>();
		for (int i = 0 ; i < perm.length ; i++) {
			orig.add(perm[i]);
		}
		boolean firstOk = false;
		for (int i = 0 ; i < perm.length ; i++) {
			int which = randomGenerator.nextInt(perm.length - i);
			if (!firstOk) {
				if (i == which) {
					i--;
					continue;
				} else
					firstOk = true;
			}
			perm[i] = ((Integer) orig.elementAt(which)).intValue();
			orig.remove(which);
		}
		return perm;
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	public synchronized static String indent(String src, int level) {
		String[] parts = src.split("\n");
		StringBuffer rez = new StringBuffer();
		String indentul = new String();
		for (int i = 0 ; i < level ; i++)
			indentul += "";
		for (int i = 0 ; i < parts.length ; i++)
			rez.append(indentul + parts[i] + "\n");
		return rez.toString();
	}

	// -----------------------------------------------------------------------------------------------------------------//
	// -----------------------------------------------------------------------------------------------------------------//
	public synchronized static int findInArray(Object[] arr, Object targ) {
		for (int i = 0 ; i < arr.length ; i++) {
			// System.out.print("Comparing " + arr[i] + " with " + targ);
			if (arr[i].equals(targ)) {
				// System.out.println("-> " +i);
				return i;
			}
		}
		// System.out.println("-> -1");
		return -1;
	}

	// -----------------------------------------------------------------------------------------------------------------//
	public synchronized static int findInVector(Vector src, Object targ) {
		for (int i = 0 ; i < src.size() ; i++) {
			// System.out.print("Comparing " + arr[i] + " with " + targ);
			if (src.elementAt(i).equals(targ)) {
				// System.out.println("-> " +i);
				return i;
			}
		}
		// System.out.println("-> -1");
		return -1;
	}

	// -----------------------------------------------------------------------------------------------------------------//
	public synchronized static boolean arrayContains(Object[] arr, Object targ) {
		// System.out.print("Searching " + targ + " in " + arrayToString(arr));
		if (findInArray(arr, targ) >= 0) {
			// System.out.println("->true");
			return true;
		} else {
			// System.out.println("->false");
			return false;
		}
	}

	// -----------------------------------------------------------------------------------------------------------------//
	public synchronized static boolean arrayContains(int[] array, int element) {
		if (findInArray(array, element) >= 0) {
			return true;
		} else {
			return false;
		}
	}

	// -----------------------------------------------------------------------------------------------------------------//

	public synchronized static Object[] union(Object[] unu, Object[] doi) {
		if (unu == null)
			return doi;
		else if (doi == null)
			return unu;
		ArrayList arrl = new ArrayList();
		for (int i = 0 ; i < unu.length ; i++) {
			if (!arrl.contains(unu[i]))
				arrl.add(unu[i]);
		}
		for (int i = 0 ; i < doi.length ; i++) {
			if (!arrl.contains(doi[i]))
				arrl.add(doi[i]);
		}
		return arrl.toArray();
	}

	// ------------------------------------------------------------------//

	public synchronized static Object[] setMinus(Object[] unu, Object[] doi) {
		ArrayList arrl = new ArrayList();
		for (int i = 0 ; i < unu.length ; i++) {
			if (!Tools.arrayContains(doi, unu[i]))
				arrl.add(unu[i]);
		}
		// System.out.print("Set minus: " + arrayToString(unu) + " \\ " +
		// arrayToString(doi));
		// System.out.println("->" + arrayToString(arrl.toArray()));
		return arrl.toArray();
	}

	public static int[] setMinus(int[] unu, int[] doi) {
		ArrayList<Integer> arrl = new ArrayList<Integer>();
		for (int i = 0 ; i < unu.length ; i++) {
			if (Tools.findInArray(doi, unu[i]) == -1)
				arrl.add(unu[i]);
		}
		// System.out.print("Set minus: " + arrayToString(unu) + " \\ " +
		// arrayToString(doi));
		// System.out.println("->" + arrayToString(arrl.toArray()));

		int[] res = new int[arrl.size()];
		for (int i = 0 ; i < arrl.size() ; i++) {
			res[i] = arrl.get(i);
		}
		return res;
	}

	// ------------------------------------------------------------------//

	public synchronized static Object[] intersection(Object[] unu, Object[] doi) {
		ArrayList arrl = new ArrayList();
		for (int i = 0 ; i < unu.length ; i++) {
			if (Tools.arrayContains(doi, unu[i]))
				arrl.add(unu[i]);
		}
		return arrl.toArray();
	}

	public synchronized static String[] intersection(String[] unu, String[] doi) {
		ArrayList<String> arrl = new ArrayList<String>();
		for (String e : unu) {
			if (Tools.arrayContains(doi, e))
				arrl.add(e);
		}
		String[] ans = new String[arrl.size()];
		for (int i = 0 ; i < arrl.size() ; i++) {
			ans[i] = arrl.get(i);
		}
		return ans;
	}

	public synchronized static String[] union(String[] unu, String[] doi) {
		ArrayList<String> array = new ArrayList<String>();
		for (String e : unu) {
			array.add(e);
		}
		for (String e : doi) {
			if (!array.contains(e)) {
				array.add(e);
			}
		}
		String[] ans = new String[array.size()];
		for (int i = 0 ; i < array.size() ; i++) {
			ans[i] = array.get(i);
		}
		return ans;
	}

	// -----------------------------------------------------------------------------------------------------------------//

	/**
	 * @param arr
	 * @param id
	 * @return the first index where the specified int appears in this array, or -1 if not found
	 */
	public synchronized static int findInArray(int[] arr, int id) {
		for (int i = 0 ; i < arr.length ; i++) {
			if (arr[i] == id)
				return i;
		}
		return -1;
	}

	// -----------------------------------------------------------------------------------------------------------------//
	public synchronized static void copyArray(Object[] srcarray, Object[] destarray) {
		copyArrayOffset(srcarray, destarray, 0);
	}

	// -----------------------------------------------------------------------------------------------------------------//
	public synchronized static void copyArrayOffset(Object[] srcarray, Object[] destarray, int offset) {
		if (srcarray.length + offset > destarray.length) {
			System.out.println("Arrays size mismatch: source has " + srcarray.length + " elements and destination has " + destarray.length
					+ " elements.");
			System.exit(1);
		}
		for (int i = 0 ; i < srcarray.length ; i++)
			destarray[i + offset] = srcarray[i];
	}

	// //
	// -----------------------------------------------------------------------------------------------------------------//
	//
	// public synchronized static String getLabel(RealVar realVar) {
	// return (new StringTokenizer(realVar.toString(), ":")).nextToken();
	// }
	//
	// //
	// -----------------------------------------------------------------------------------------------------------------//
	//
	// public synchronized static String getLabel(IntVar intVar) {
	// return (new StringTokenizer(intVar.toString(), ":")).nextToken();
	// }

	// -----------------------------------------------------------------------------------------------------------------//
	public synchronized static void copyArray(int[] srcarray, int[] destarray) {
		copyArrayOffset(srcarray, destarray, 0);
	}

	// -----------------------------------------------------------------------------------------------------------------//
	public synchronized static void copyArrayOffset(int[] srcarray, int[] destarray, int offset) {
		if (srcarray.length + offset > destarray.length) {
			System.out.println("Arrays size mismatch: source has " + srcarray.length + " elements and destination has " + destarray.length
					+ " elements.");
			System.exit(1);
		}
		for (int i = 0 ; i < srcarray.length ; i++)
			destarray[i + offset] = srcarray[i];
	}

	// -----------------------------------------------------------------------------------------------------------------//
	/*
	 * public synchronized static Value ValuefromString(String stringValue) { stringValue = stringValue.trim(); if(ParameterTypes.isInt(stringValue))
	 * return new IntValue(Integer.parseInt(stringValue)); else if(stringValue.startsWith("[")){ String bounds[] = stringValue.split(","); double inf
	 * = Double.parseDouble(bounds[0].substring(1)); bounds[1] = bounds[1].split("]")[0]; double sup = Double.parseDouble( bounds[1]); return new
	 * RealValue(inf,sup); } return new nullValue(); }
	 */
	// -----------------------------------------------------------------------------------------------------------------//
	public synchronized static BitSet BitSetFromString(String str) { // {1, 3,
		// 323 }
		BitSet b = new BitSet();
		str.trim();
		str = str.substring(1);
		str = str.substring(0, str.indexOf('}'));
		StringTokenizer tok = new StringTokenizer(str.trim(), ",");
		while (tok.hasMoreTokens())
			b.set(Integer.parseInt(tok.nextToken().trim()), true);

		return b;
	}

	public static String[] splitString(String str, char ch) {
		char[] chrs = str.toCharArray();
		int nbr = 0;
		for (int i = 0 ; i < chrs.length ; i++)
			if (chrs[i] == ch)
				nbr++;
		Vector sb = new Vector();
		String[] strs = new String[nbr + 1];
		int i = 0;
		for (int c = 0 ; c < chrs.length ; c++) {
			if (chrs[c] != ch) {
				sb.add(chrs[c]);
			} else {
				strs[i] = VtoString(sb);
				sb = new Vector();
				i++;
			}
		}
		strs[i] = VtoString(sb);
		return strs;
	}

	private static String VtoString(Vector v) {
		String s = new String();
		for (int i = 0 ; i < v.size() ; i++)
			s += v.get(i);
		return s;
	}

	public static void waitKey() {
		try {
			System.in.read();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	// -----------------------------------------------------------------------------------------------------------------//

	public static String convertXMLFileToString(String fileName) {
		try {
			DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
			InputStream inputStream = new FileInputStream(new File(fileName));
			org.w3c.dom.Document doc = documentBuilderFactory.newDocumentBuilder().parse(inputStream);
			StringWriter stw = new StringWriter();
			Transformer serializer = TransformerFactory.newInstance().newTransformer();
			serializer.transform(new DOMSource(doc), new StreamResult(stw));
			return stw.toString();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}

	public static HashMap<Integer, IntArray> mapIntegerIntArrayfromString(String str) {
		str = str.substring(str.indexOf("{") + 1, str.indexOf("}"));// remove { and }
		HashMap<Integer, IntArray> agNeig = new HashMap<Integer, IntArray>();
		StringTokenizer tok = new StringTokenizer(str, ",");
		while (tok.hasMoreTokens()) {
			StringTokenizer t = new StringTokenizer(tok.nextToken(), "=");
			int agId = Integer.parseInt(t.nextToken().replaceAll(" ", ""));
			IntArray neig = IntArray.fromString(t.nextToken());
			agNeig.put(agId, neig);
		}
		return agNeig;
	}

	public static HashMap<Integer, Integer> mapIntegerIntegerfromString(String str) {
		HashMap<Integer, Integer> ans = new HashMap<Integer, Integer>();
		String map = str.substring(str.indexOf("{") + 1, str.indexOf("}"));// remove { and }
		StringTokenizer tok = new StringTokenizer(map, ",");
		while (tok.hasMoreTokens()) {
			StringTokenizer t = new StringTokenizer(tok.nextToken(), "=");
			int key = Integer.parseInt(t.nextToken().replaceAll(" ", ""));
			int value = Integer.parseInt(t.nextToken().replaceAll(" ", ""));
			ans.put(key, value);
		}
		return ans;
	}

	public static void main(String[] args) {
		// LinkedList<String> box = new LinkedList<String>();
		// box.addLast("A");
		// box.addLast("B");
		// box.addLast("C");
		// box.addLast("D");
		// box.addLast("E");
		// Iterator<String> it = box.iterator();
		// System.out.println(box);
		// while (it.hasNext()) {
		// System.out.println(it.next());
		// }
		int[] tab = {1, 5, 9, 6, 3};
		System.out.println(Tools.arrayToString(tab));
		TreeSet<Integer> treeSet = Tools.arrayToTreeSet(tab);
		System.out.println(treeSet.toString());
		int[] tab1 = Tools.arrayFromTreeSet(treeSet);
		System.out.println(Tools.arrayToString(tab1));

	}

	// //////////////////////////////////////////////////////////////////////////////////////
	// //////////////////////////////////////////////////////////////////////////////////////
	// //////////////////////////////////////////////////////////////////////////////////////
	// //////////////////////////////////////////////////////////////////////////////////////

	public synchronized static final long Factorial(long n) {
		BigInteger fac = BigInteger.ONE;
		for (int i = 1 ; i <= n ; i++) {
			fac = fac.multiply(BigInteger.valueOf(i));
		}
		long f = fac.longValue();
		if (f == 0) { return 1; }
		return f;
	}

	public synchronized static final long Arrangement(long k, long n) {
		if (k > n) { return 0; }
		if (k == 1)
			return n;
		if (k == n)
			return Factorial(n);
		long res = 0;
		res = Factorial(n) / Factorial(n - k);
		return res;
	}

	/**
	 * combinaison de k parmi n
	 * 
	 * @param k
	 * @param n
	 */
	public synchronized static final long C(long n, long k) {
		if (k == 1)
			return n;
		return Arrangement(k, n) / Factorial(k);
	}

	public static int indexOf(int[] data, int element) {
		for (int i = 0 ; i < data.length ; i++) {
			if (data[i] == element) { return i; }
		}
		return -1;
	}

	public static int[] subArray(int[] data, int from, int to) {
		int[] array = new int[to - from];
		for (int i = 0 ; i < array.length ; i++) {
			array[i] = data[i + from];
		}
		return array;
	}

	public static String statisticsToString(ArrayList<String> keys, HashMap<String, Double> statistics) {
		String res = statistics.get(Commands.MSGs) + ", " + 
		statistics.get(Commands.NCCCs) + ", " + 
		statistics.get(Commands.GNCCCs) + ", " + 
		statistics.get(Commands.CCs) + ", " + 
		statistics.get(Commands.SOLVABLE) + ", ";
		DecimalFormat df = new DecimalFormat("0.###");
//		DecimalFormat df = new DecimalFormat() ; 
//		df.setMaximumFractionDigits(3); //arrondi  2 chiffres apres la virgules 
		df.setMinimumFractionDigits(2); 
		df.setDecimalSeparatorAlwaysShown ( true ) ;
		for (String key : keys) {
			if (!key.equals(Commands.NCCCs) && !key.equals(Commands.GNCCCs)&& !key.equals(Commands.CCs) 
					&& !key.equals(Commands.MSGs) && !key.equals(Commands.SOLVABLE)) {
				if (statistics.containsKey(key)) {
					String value = df.format(statistics.get(key)); 
					res += value.replace(',', '.') + ", "; 
				} else {
					res += "0, ";
				}
			}
		}
		return res;
	}

	public static String statisticsKeyToString(HashMap<String, Long> runStatistics) {
		String keys = Commands.MSGs + ", " + Commands.NCCCs + ", " + 
		Commands.GNCCCs + ", " + Commands.CCs + ", " + Commands.SOLVABLE + ", ";
		Iterator<String> itr = runStatistics.keySet().iterator();
		while (itr.hasNext()) {
			String key = itr.next();
			if (!key.equals(Commands.NCCCs) && !key.equals(Commands.GNCCCs)&& !key.equals(Commands.CCs) 
					&& !key.equals(Commands.MSGs) && !key.equals(Commands.SOLVABLE)) {
				keys += key;
				if (itr.hasNext()) {
					keys += ", ";
				}
			}
		}
		return keys;
	}

	public static String dataKeyToString(HashMap<String, Integer> keysMap) {
		String keys = Commands.MSGs + "," + Commands.NCCCs + "," + Commands.GNCCCs + "," + Commands.CCs 
		+ "," + Commands.SOLVABLE + ",";
		Iterator<String> itr = keysMap.keySet().iterator();
		while (itr.hasNext()) {
			String key = itr.next();
			if (!key.equals(Commands.NCCCs) && !key.equals(Commands.GNCCCs) && !key.equals(Commands.CCs) 
					&& !key.equals(Commands.MSGs) && !key.equals(Commands.SOLVABLE)) {
				keys += key;
				if (itr.hasNext()) {
					keys += ",";
				}
			}
		}
		return keys;
	}

	// ////////////////////////////////////////////////////////////////////////////////////
	/**
	 * We compare two arrays, which are supposed to have the same length
	 * 
	 * @param array1
	 * @param array2
	 * @return <b><i>+(i+1)</i></b> if <b>array1</b> is the lowest (<b> <i>array1 < array2</i></b> )<br/>
	 *         <b><i> 0</i></b> if <b>array1</b> and <b>array2</b> are equal<br/>
	 *         <b><i>-(i+1)</i></b> if <b>array2</b> is the best(<b><i>array1 > array2</i></b>)<br/>
	 */
	public static int compare(double array1[], double[] array2) {
		for (int i = 0 ; i < array1.length ; i++) {
			if (array2[i] > array1[i]) {
				return i + 1;
			} else if (array2[i] < array1[i]) { return -(i + 1); }
		}
		return 0;
	}

	// -----------------------------------------------------------------------------------------------------------------------//
	public synchronized static String arrayToString(double[] array) {
		if (array == null) { return "null"; }
		StringBuffer sb = new StringBuffer("[");
		for (int i = 0 ; i < array.length - 1 ; i++) {
			sb.append(array[i] + " ");
		}
		sb.append(array[array.length - 1]);
		sb.append("]");
		return sb.toString();
	}

	public synchronized static double[] DoubleArrayFromString(String str) {
		if (str.startsWith("["))
			str = str.substring(1, str.indexOf("]")); // remove [ and ]
		if (str == null)
			return null;// new int[0];
		StringTokenizer tok = new StringTokenizer(str);
		double[] array = new double[tok.countTokens()];
		int i = 0;
		while (tok.hasMoreTokens()) {
			array[i++] = Double.parseDouble(tok.nextToken());
		}
		return array;
	}

	/**
	 * @param keys
	 * @return
	 */
	public static String toString(ArrayList<String> keys) {
		String str = keys.toString();
		return str.substring(1, str.length()-1);
	}

	/**
	 * @param domDeg
	 * @return
	 */
	public static int MaxOf(HashMap<Integer, Double> map) {
		int max = map.keySet().iterator().next();
		for(int key : map.keySet()){
			double value = map.get(key);
			if(value > map.get(max)){
				max = key ; 
			}
		}
		return max;
	}

	/**
	 * @param domDeg
	 * @return
	 */
	public static Integer MaxOf(HashMap<Integer, Integer> map) {
		int maxKey = map.keySet().iterator().next();
		int maxValue = map.get(maxKey);
		for(int key : map.keySet()){
			int value = map.get(key);
			if(value > maxValue){
				maxKey = key ;
				maxValue = value;
			}
		}
		return maxKey;
	}

	/**
	 * @param domDeg
	 * @return
	 */
	public static int MinOf(HashMap<Integer, Double> map, IntArray elements) {
		int min = map.keySet().iterator().next();
		for(int key : elements){
			double value = map.get(key);
			if(value < map.get(min)){
				min = key ; 
			}
		}
		return min;
	}

	/**
	 * @param domDeg
	 * @return
	 */
	public static int MinOf(HashMap<Integer, Double> map) {
		int minKey = map.keySet().iterator().next();
		double minValue = map.get(minKey);
		for(int key : map.keySet()){
			double value = map.get(key);
			if(value < minValue){
				minKey = key ;
				minValue = value;
			}
		}
		return minKey;
	}

	/**
	 * @param domDeg
	 * @return
	 */
	public static Integer MinOf(HashMap<Integer, Integer> map) {
		int minKey = map.keySet().iterator().next();
		int minValue = map.get(minKey);
		for(int key : map.keySet()){
			int value = map.get(key);
			if(value < minValue){
				minKey = key ; 
				minValue = value;
			}
		}
		return minKey;
	}
}
